/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: can_if.c 122 2015-07-17 01:31:28Z ertl-honda $
 */
#include "Os.h"
#include "can_if.h"
#include "hsbrh850f1l_device.h"
#include "prc_sil.h"

/*
 *  Port 0 Configration for RSCAN0
 *   P10_1 : RSCAN0_TX : 2
 *   P10_0 : RSCAN0_RX : 2
 */
#define RSCAN0_P10_MASK			((uint16) 0x0003)
#define RSCAN0_PMC10_INIT		((uint16) 0x0003)
#define RSCAN0_PFCAE10_INIT		((uint16) 0x0000)
#define RSCAN0_PFCE10_INIT		((uint16) 0x0000)
#define RSCAN0_PFC10_INIT		((uint16) 0x0003)
#define RSCAN0_PM10_INIT		((uint16) 0x0001)
#define RSCAN0_PIBC10_INIT		((uint16) 0x0001)

/*
 *   rscan_port_init();
 */
static void
rscan_port_init(void) {
	uint16 wk;

	/*
	 *  CAN0
	 *   RX : P10_1
	 *   TX : P10_0
	 */
	/* PFCAE0  */
	wk = sil_reh_mem((void *) PFCAE(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PFCAE10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PFCAE(10), wk);

	/* PFCE0  */
	wk = sil_reh_mem((void *) PFCE(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PFCE10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PFCE(10), wk);

	/* PFC0  */
	wk = sil_reh_mem((void *) PFC(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PFC10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PFC(10), wk);

	/* PMC0  */
	wk = sil_reh_mem((void *) PMC(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PMC10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PMC(10), wk);

	/* PM0  */
	wk = sil_reh_mem((void *) PM(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PM10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PM(10), wk);

	/* PIBC0  */
	wk = sil_reh_mem((void *) PIBC(10));
	wk &= ~RSCAN0_P10_MASK;
	wk |= (RSCAN0_PIBC10_INIT & RSCAN0_P10_MASK);
	sil_wrh_mem((void *) PIBC(10), wk);

	/* CANȥ󥷡ХݡȽ(CanTrcv¸ߤʤᡤǽ) */
	sil_wrh_mem((void *) P(9U), sil_reh_mem((void *) P(9U)) & 0xFFFDU);
	sil_wrh_mem((void *) PM(9U), sil_reh_mem((void *) PM(9U)) & 0xFFFDU);
	sil_wrh_mem((void *) PMC(9U), sil_reh_mem((void *) PMC(9U)) & 0xFFFDU);
}

/* C_ISO_CANOSCåʬ쥸 */
#define CKSC_ICANOSCD_CTL			0xFFF8AA00U

static void
rscan_clock_init() {
	/* CANǻѤ륯å(C_ISO_CANOSC) ᥤ󥯥å(MainOsc)ꤹ */
	sil_wrw_mem((void *) PROTCMD1, 0x000000A5U);
	sil_wrw_mem((void *) CKSC_ICANOSCD_CTL, 0x00000001U);
	sil_wrw_mem((void *) CKSC_ICANOSCD_CTL, 0xFFFFFFFEU);
	sil_wrw_mem((void *) CKSC_ICANOSCD_CTL, 0x00000001U);
}

/*
 *  CANν
 */
void
tCanInit(void)
{
	rscan_clock_init();

	rscan_port_init();

	/* CAM */
	RsCanInit(0);
}

void
tCanSetMailBoxInfo(uint8 mb_id, uint8 direction,
								uint32 id, uint8 mask)
{
	RsCanSetMailBoxInfo(0, mb_id, direction, 0, id, mask, 0);
}

/*
 *  CANͭ
 */
void
tCanEnable(void)
{
	RsCanEnable(0);
}

/*
 *  CANǡμ
 */
uint8
tCanGetRxData(uint8 mb_id, uint8 id, uint8 *p_data, uint8 *p_len){
	return RsCanGetRxData(0, mb_id, p_data, p_len);
}

/*
 *  CANǡ
 */
uint8
tCanSetTxData(uint8 mb_id, uint8 id, uint8 *p_data, uint8 len){
	return RsCanSetTxData(0, mb_id, id, p_data, len);
}
